#!/bin/bash
###                                        ###
#      Created on 1/28-2013 by remote.       #
# ZAXTER. home of SI/OP all rights reserved. #
#                                            #
#  Logs racers name, start and finish time.  #
###                                        ###

header() {
  clear
  tput rev
  echo " ==================================================="
  echo "                 Simple I/O Project.                "
  echo "            Mud Bog single lap track times.         "
  echo -n " ""SI/OP   Date & Time:   "
date
  echo "                                                    "
  echo "    To start race type racers name and hit enter.   "
  echo "                                                    "
  echo "   Otherwise type one of the following then enter:  "
  echo " Event     :Posts event or class name into log.     "
  echo " Log       :Views history. Use cursor, Page, End,   "
  echo "            Home, to move around and q to return.   "
  echo " Quit      :Leaves this program.                    "
  echo " ==================================================="
  tput rmso
  echo ''
  read NEW_RACER
    case $NEW_RACER in
	    Quit|quit|QUIT|qUIT|q)        clean_up;;
	    Log|log|LOG|lOG)              view_log;;
	    Event|event|EVENT|eVENT)	  event_name;;
	    [a-zA-Z0-0]*)		  pre-stage;;
    esac
}

pre-stage(){
echo $NEW_RACER >> laps_times
stage_line
#start_time
}

stage_line(){
VALUE_STAGE_LINE=`cat /home/siop/port2/input/pin10`
  if [ $VALUE_STAGE_LINE = 1 ] ; then
    echo "Staged," `date '+%H:%M:%S:%N'` >> laps_times
    echo `date '+%H%M%S.%N'` > temp_stage_time
    echo "$NEW_RACER is staged."
    date '+%H:%M:%S:%N'
tree_out
  else
    sleep .0005
stage_line
  fi
clear
}

tree_out(){
  echo 1 > /home/siop/port2/output/pin1
  sleep .9
  echo 0 > /home/siop/port2/output/pin1
  echo 1 > /home/siop/port2/output/pin2
  sleep .5
  echo 0 > /home/siop/port2/output/pin2
  echo 1 > /home/siop/port2/output/pin3
red_light_check
}

red_light_check(){
VALUE_STAGE_LIGHT=`cat /home/siop/port2/output/pin1`
VALUE_YELLOW_LIGHT=`cat /home/siop/port2/output/pin2`
VALUE_GREEN_LIGHT=`cat /home/siop/port2/output/pin3`
VALUE_STARTING_LINE=`cat /home/siop/port2/input/pin11`
  if [ $((VALUE_STAGE_LIGHT+VALUE_YELLOW_LIGHT+VALUE_GREEN_LIGHT+VALUE_STARTING_LINE)) -gt 1  ] ; then
    echo Red lights, `date '+%H:%M:%S:%N'` >> laps_times
    echo " " >> laps_times
red_light
  else
start_time
  fi
}

start_time(){
VALUE_STARTING_LINE=`cat /home/siop/port2/input/pin11`
  if [ $VALUE_STARTING_LINE = 1 ] ; then
    echo Starts, `date '+%H:%M:%S:%N'` >> laps_times
    echo `date '+%H%M%S.%N'` > temp_start_time
    echo "$NEW_RACER starts"
    date '+%H:%M:%S:%N'
    echo 0 > /home/siop/port2/output/pin3
    ETSG=`cat temp_stage_time`
    ETS=`cat temp_start_time`
    (echo -n "RT, "; echo "$ETS-$ETSG-1.4" |bc) >> laps_times
stop_time
  else
    sleep .0005
start_time
  fi
clear
}

stop_time(){
VALUE_FINISH_LINE=`cat /home/siop/port2/input/pin15`
  if [ $VALUE_FINISH_LINE = 1 ] ; then
    echo Finished, `date '+%H:%M:%S:%N'` >> laps_times
    echo `date '+%H%M%S.%N'` > temp_finish_time
    ETF=`cat temp_finish_time`
    ETS=`cat temp_start_time`
    (echo -n "ET, "; echo "$ETF-$ETS" |bc) >> laps_times
    echo " " >> laps_times
header
  else
    sleep .0005
stop_time
  fi
} 

red_light(){
  echo 0 > /home/siop/port2/output/pin3
  echo 1 > /home/siop/port2/output/pin4
  echo LMAO at $NEW_RACER
  sleep 3
  echo 0 > /home/siop/port2/output/pin4
  clear
header
}

event_name(){
  echo "Enter name of Event or Class and hit enter."
  read NEW_EVENT
  case $NEW_EVENT in
	[a-zA-Z0-0]*)	echo $NEW_EVENT >> laps_times;;
  esac
}

view_log(){
#  less /home/siop/laps_times
  less ./laps_times
  clear
header
}

clean_up() {
  clear
  exit
}

while true ; do
header
done
echo

### Instructions
# Alter port and pins to your liking.
# Pins 10,11,15 are Stage, Start and Finish sensor inputs.
# Pins 1 - 4 are Staged, Yellow, Green and Red light outputs.
# If you do not want the stage and light tree feature,
# Add a # to line 38 stage_line and remove the # from line #39 stage_time
###

