#!/bin/bash
###                                        ###
#      Created on 9/1-2008 by remote.        #
# ZAXTER. home of SI/OP all rights reserved. #
#                                            #
#      Choose which interface board.         #
#         4/6-2013 for SI/OP use.            #
###                                        ###

. ./BIS.data # Reference file to store scripts data.
header() {
OLD_OUTPUT_CHOICE=$(for N in /home/siop/$CONTROL_PORT_CHOICE/output/$PIN_NUM /home/siop/$CONTROL_PORT_CHOICE/output/$PIN__NUM /home/siop/$CONTROL_PORT_CHOICE/output/$PIN___NUM /home/siop/$CONTROL_PORT_CHOICE/output/$PIN____NUM; do cat $N ; echo  -n " " ; done | paste -sd " "|sed 's/ /  /g')
OLD_INPUT_CHOICE=$(for N in /home/siop/$PORT_CHOICE/input/pin$PINNUM0 /home/siop/$PORT_CHOICE/input/pin$PINNUM1 /home/siop/$PORT_CHOICE/input/pin$PINNUM2 /home/siop/$PORT_CHOICE/input/pin$PINNUM3 /home/siop/$PORT_CHOICE/input/pin$PINNUM4; do cat $N ; echo  -n " " ; done | paste -sd " "|sed 's/ /  /g')
INTERFACE=`cat /home/siop/$PORT_CHOICE/output/pin[1234]`
 if [ $INTERFACE = 0000 ]
  then VALUE_A="0                        "
 elif [ $INTERFACE = 0001 ]
  then VALUE_A="1                        "
 elif [ $INTERFACE = 0010 ]
  then VALUE_A="2                        "
 elif [ $INTERFACE = 0011 ]
  then VALUE_A="3                        "
 elif [ $INTERFACE = 0100 ]
  then VALUE_A="4                        "
 elif [ $INTERFACE = 0101 ]
  then VALUE_A="5                        "
 elif [ $INTERFACE = 0110 ]
  then VALUE_A="6                        "
 elif [ $INTERFACE = 0111 ]
  then VALUE_A="7                        "
 elif [ $INTERFACE = 1000 ]
  then VALUE_A="8                        "
 elif [ $INTERFACE = 1001 ]
  then VALUE_A="9                        "
 elif [ $INTERFACE = 1010 ]
  then VALUE_A="10                       "
 elif [ $INTERFACE = 1011 ]
  then VALUE_A="11                       "
 elif [ $INTERFACE = 1100 ]
  then VALUE_A="12                       "
 elif [ $INTERFACE = 1101 ] 
  then VALUE_A="13                       "
 elif [ $INTERFACE = 1110 ]
  then VALUE_A="14                       "
 elif [ $INTERFACE = 1111 ]
  then VALUE_A="15                       "
    else VALUE_A=" Oops"
 fi
ON_OFF=`cat /home/siop/$PORT_CHOICE/output/$PIN_____NUM`
 if [ $ON_OFF = 0 ]
  then O=On" "\ 
  else O=Off\  
 fi
  clear
## Remove the # from the line below and in front of tput rmso
 tput rev
  echo "============================================="
  echo "             Simple I/O Project.             " 
  echo " SI/OP   BinaryInterfaceSelector.sh          "
  echo -n " Date & Time:    "
date
  echo "                                             "
  echo "     74154 Status : $O                     "
  echo "     Enter which PCB 0  -  15  to monitor.   "
  echo "     Interfrace PCB $VALUE_A"
  echo "     Pins $PINNUM0 $PINNUM1 $PINNUM2 $PINNUM3 $PINNUM4                     "
  echo "          $OLD_INPUT_CHOICE                    "
  echo "     LPT: $PORT_CHOICE                              "
  echo "                                             "
  echo "  Pi           :Change pin numbers.          "
  echo "  Po           :Change port number.          "
  echo "  On           :Turns on 74154 output.       "
  echo "  Off          :Turns off 74154 output.      "
  echo "  S            :Switch status of output pins."
  echo "  Quit         :Leaves this program.         "
#  echo '' 
  tput rmso
  echo "Hit enter to refresh.                                  "
  read NEW_EVENT
    case $NEW_EVENT in
	    Quit|quit|QUIT|qUIT|Q|q)        clean_up;;
            0|a)                                  zero;;
	    1|b)				  one;;
	    2|c)				  two;;
	    3|d)				  three;;
	    4|e)				  four;;
	    5|f)				  five;;
	    6|g)				  six;;
	    7|h)				  seven;;
	    8|i)				  eight;;
	    9|j)				  nine;;
	    10|k)				  ten;;
	    11|l)				  elven;;
	    12|m)				  twelve;;
	    13|n)				  thirteen;;
	    14|o)				  fourteen;;
	    15|p)				  fifteen;;
            Pi|pi|PI|pI)                          pinnumbers;;
            Po|po|PO|pO)                          portnumber;;
	    On|on|ON|oN)		  on;;
	    Off|off|OFF|oFF)		  off;;
    esac
}

clean_up() {
  clear
  exit
}

zero(){
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

one(){
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

two(){
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

three(){
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

four(){
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

five(){
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

six(){
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

seven(){
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

eight(){
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

nine(){
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

ten(){
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

elven(){
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

twelve(){
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

thirteen(){
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

fourteen(){
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

fifteen(){
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN_NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN__NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN___NUM
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN____NUM
}

# Below is an added feature of On/Off, change pin number to your liking.
# Comment it out if not wanted.
on(){
  echo 0 > /home/siop/$PORT_CHOICE/output/$PIN_____NUM
}

off(){
  echo 1 > /home/siop/$PORT_CHOICE/output/$PIN_____NUM
}

pinnumbers(){
  echo "Finish this!"
sleep 2
}

portnumber(){
  echo "Finish this too!"
sleep 2
}

while true ; do
header
done
echo

### Instructions
# Add your coding notes here if you like.
# Change port and pin numbers to match your setup.
# 
# 
###

