#!/bin/bash
###                                        ###
#      Created on 9/1-2008 by remote.        #
# ZAXTER. home of SI/OP all rights reserved. #
#                                            #
#      DC Motor Speed via Switcher.          #
#         4/6-2013 for SI/OP use.            #
###                                        ###

header() {
OLD_OUTPUT_CHOICE=$(for N in /home/siop/port2/output/pin2 /home/siop/port2/output/pin3 /home/siop/port2/output/pin4 /home/siop/port2/output/pin5 /home/siop/port2/output/pin6 ; do cat $N ; echo  -n " " ; done | paste -sd " "|sed 's/ /  /g')
SPEED=`cat /home/siop/port2/output/pin[2345]`
 if [ $SPEED = 0000 ]
  then VALUE_A="- - - - - - - - - - - - - - - -                "
 elif [ $SPEED = 1000 ]
  then VALUE_A="- - - - - - - - - - - - - - -                  "
 elif [ $SPEED = 0100 ]
  then VALUE_A="- - - - - - - - - - - - - -                    "
 elif [ $SPEED = 1100 ]
  then VALUE_A="- - - - - - - - - - - - -                      "
 elif [ $SPEED = 0010 ]
  then VALUE_A="- - - - - - - - - - - -                        "
 elif [ $SPEED = 1010 ]
  then VALUE_A="- - - - - - - - - - -                          "
 elif [ $SPEED = 0110 ]
  then VALUE_A="- - - - - - - - - -                            "
 elif [ $SPEED = 1110 ]
  then VALUE_A="- - - - - - - - -                              "
 elif [ $SPEED = 0001 ]
  then VALUE_A="- - - - - - - -                                "
 elif [ $SPEED = 1001 ]
  then VALUE_A="- - - - - - -                                  "
 elif [ $SPEED = 0101 ]
  then VALUE_A="- - - - - -                                    "
 elif [ $SPEED = 1101 ]
  then VALUE_A="- - - - -                                      "
 elif [ $SPEED = 0011 ]
  then VALUE_A="- - - -                                        "
 elif [ $SPEED = 1011 ]
  then VALUE_A="- - -                                          "
 elif [ $SPEED = 0111 ]
  then VALUE_A="- -                                            "
 elif [ $SPEED = 1111 ]
  then VALUE_A="-                                              "
    else VALUE_A=" Oops"
 fi
ON_OFF=`cat /home/siop/port2/output/pin6`
 if [ $ON_OFF = 0 ]
  then O=Off VALUE_A="                                               "
  else O=On\ 
 fi
  clear
## Remove the # from the line below and in front of tput rmso
# tput rev
  echo "======================================================="
  echo "                 Simple I/O Project.                   "
  echo "             DC Motor Speed via Switcher.              "
  echo -n "  ""SI/OP   Date & Time:     "
date
  echo "                                                       "
  echo "      Output Status :  $O                             "
  echo "      Pins 2  3  4  5  6                               "
  echo "           $OLD_OUTPUT_CHOICE                             "
  echo "                                                       "
  echo " Enter 1              -              16 and hit enter. "
  echo " Speed $VALUE_A "
  echo "                                                       "
  echo " On           :Turns on output.                        "
  echo " Off          :Turns off output.                       "
  echo " Quit         :Leaves this program.                    "
  echo ''
#  tput rmso

  read NEW_EVENT
    case $NEW_EVENT in
	    Quit|quit|QUIT|qUIT|Q|q)        clean_up;;
	    1|a)				  one;;
	    2|s)				  two;;
	    3|d)				  three;;
	    4|f)				  four;;
	    5|g)				  five;;
	    6|h)				  six;;
	    7|j)				  seven;;
	    8|k)				  eight;;
	    9|l)				  nine;;
	    10|z)				  ten;;
	    11|x)				  elven;;
	    12|c)				  twelve;;
	    13|v)				  thirteen;;
	    14|b)				  fourteen;;
	    15|n)				  fifteen;;
	    16|m)				  sixteen;;
	    On|on|ON|oN)		  on;;
	    Off|off|OFF|oFF)		  off;;
    esac
}

clean_up() {
  clear
  exit
}

one(){
  echo 1 > /home/siop/port2/output/pin2
  echo 1 > /home/siop/port2/output/pin3
  echo 1 > /home/siop/port2/output/pin4
  echo 1 > /home/siop/port2/output/pin5
}

two(){
  echo 0 > /home/siop/port2/output/pin2
  echo 1 > /home/siop/port2/output/pin3
  echo 1 > /home/siop/port2/output/pin4
  echo 1 > /home/siop/port2/output/pin5
}

three(){
  echo 1 > /home/siop/port2/output/pin2
  echo 0 > /home/siop/port2/output/pin3
  echo 1 > /home/siop/port2/output/pin4
  echo 1 > /home/siop/port2/output/pin5
}

four(){
  echo 0 > /home/siop/port2/output/pin2
  echo 0 > /home/siop/port2/output/pin3
  echo 1 > /home/siop/port2/output/pin4
  echo 1 > /home/siop/port2/output/pin5
}

five(){
  echo 1 > /home/siop/port2/output/pin2
  echo 1 > /home/siop/port2/output/pin3
  echo 0 > /home/siop/port2/output/pin4
  echo 1 > /home/siop/port2/output/pin5
}

six(){
  echo 0 > /home/siop/port2/output/pin2
  echo 1 > /home/siop/port2/output/pin3
  echo 0 > /home/siop/port2/output/pin4
  echo 1 > /home/siop/port2/output/pin5
}

seven(){
  echo 1 > /home/siop/port2/output/pin2
  echo 0 > /home/siop/port2/output/pin3
  echo 0 > /home/siop/port2/output/pin4
  echo 1 > /home/siop/port2/output/pin5
}

eight(){
  echo 0 > /home/siop/port2/output/pin2
  echo 0 > /home/siop/port2/output/pin3
  echo 0 > /home/siop/port2/output/pin4
  echo 1 > /home/siop/port2/output/pin5
}

nine(){
  echo 1 > /home/siop/port2/output/pin2
  echo 1 > /home/siop/port2/output/pin3
  echo 1 > /home/siop/port2/output/pin4
  echo 0 > /home/siop/port2/output/pin5
}

ten(){
  echo 0 > /home/siop/port2/output/pin2
  echo 1 > /home/siop/port2/output/pin3
  echo 1 > /home/siop/port2/output/pin4
  echo 0 > /home/siop/port2/output/pin5
}

elven(){
  echo 1 > /home/siop/port2/output/pin2
  echo 0 > /home/siop/port2/output/pin3
  echo 1 > /home/siop/port2/output/pin4
  echo 0 > /home/siop/port2/output/pin5
}

twelve(){
  echo 0 > /home/siop/port2/output/pin2
  echo 0 > /home/siop/port2/output/pin3
  echo 1 > /home/siop/port2/output/pin4
  echo 0 > /home/siop/port2/output/pin5
}

thirteen(){
  echo 1 > /home/siop/port2/output/pin2
  echo 1 > /home/siop/port2/output/pin3
  echo 0 > /home/siop/port2/output/pin4
  echo 0 > /home/siop/port2/output/pin5
}

fourteen(){
  echo 0 > /home/siop/port2/output/pin2
  echo 1 > /home/siop/port2/output/pin3
  echo 0 > /home/siop/port2/output/pin4
  echo 0 > /home/siop/port2/output/pin5
}

fifteen(){
  echo 1 > /home/siop/port2/output/pin2
  echo 0 > /home/siop/port2/output/pin3
  echo 0 > /home/siop/port2/output/pin4
  echo 0 > /home/siop/port2/output/pin5
}

sixteen(){
  echo 0 > /home/siop/port2/output/pin2
  echo 0 > /home/siop/port2/output/pin3
  echo 0 > /home/siop/port2/output/pin4
  echo 0 > /home/siop/port2/output/pin5
}

on(){
  echo 1 > /home/siop/port2/output/pin6
}

off(){
  echo 0 > /home/siop/port2/output/pin6
}

while true ; do
header
done
echo

### Instructions
# Add your coding notes here if you like.
# Change port and pin numbers to match your setup.
# 
# 
###

