#!/bin/bash
###                                        ###
#      Created on 01/01-2013 by remote.      #
# ZAXTER. home of SI/OP all rights reserved. #
#                                            #
#    Last modified 03/12-2022 via remote.    #
#       Content Description "usage."         #
###                                        ###

watch_state() {
VALUE_NEITHER=3
VALUE_A=`cat /home/siop/port1/input/pin12`
VALUE_X=0
  if [ $VALUE_A = $VALUE_X -a $VALUE_A != $VALUE_NEITHER ] ; then
	echo "clockwise" >> rev-switch.text
	date >> rev-switch.text
    clockwise_full_step
VALUE_NEITHER=$VALUE_A
elif [ $VALUE_A != $VALUE_X -a $VALUE_A != $VALUE_NEITHER ] ; then
	echo "counterclockwise" >> rev-switch.text
	date >> rev-switch.text
    counterclockwise_half_step
VALUE_NEITHER=$VALUE_A
fi
}

clockwise_full_step() {
correlative_numbers=$(for N in /home/siop/scripts/bash/rate ; do cat $N ; echo  -n " " ; done )
echo 1 > /home/siop/port1/output/pin7
sleep $correlative_numbers
echo 0 > /home/siop/port1/output/pin6
echo 1 > /home/siop/port1/output/pin8
sleep $correlative_numbers
echo 0 > /home/siop/port1/output/pin7
echo 1 > /home/siop/port1/output/pin9
sleep $correlative_numbers
echo 0 > /home/siop/port1/output/pin8
echo 1 > /home/siop/port1/output/pin6
sleep $correlative_numbers
echo 0 > /home/siop/port1/output/pin9
}

counterclockwise_half_step() {
correlative_numbers=$(for N in /home/siop/scripts/bash/rate2 ; do cat $N ; echo  -n " " ; done )
echo 1 > /home/siop/port1/output/pin9
sleep $correlative_numbers
echo 1 > /home/siop/port1/output/pin8
echo 0 > /home/siop/port1/output/pin9
sleep $correlative_numbers
echo 1 > /home/siop/port1/output/pin7
echo 0 > /home/siop/port1/output/pin8
sleep $correlative_numbers
echo 1 > /home/siop/port1/output/pin6
echo 0 > /home/siop/port1/output/pin7
sleep $correlative_numbers
echo 0 > /home/siop/port1/output/pin6
}

while true
do
watch_state
done
