#!/bin/bash
###                                        ###
#      Created on 7/19-2006 by remote.       #
# ZAXTER. home of SI/OP all rights reserved. #
#    Last modified 10/15-2010 via remote.    #
#  Changes made for spp mode and new daemon. #
###                                        ###


# Load config values. #
#source ./siop.config
. ./temp.data

bs=':						:'

header() {
  clear
 tput rev
  echo "================================================="
  echo "               Simple I/O Project.               "
  echo "    SI/OP         Status01.sh                    "
  echo -n "    Date & Time:     "
date
  echo "$bs" 
 tput rmso
}

show_current_settings() {
. ./temp.data

OLD_INPUT_CHOICE=$(for N in  /home/siop/${PORT_CHOICE}/input/* ; do cat $N ; echo  -n " " ; done | paste -sd " "|sed 's/ /  /g')

OLD_OUTPUT_CHOICE=$(for N in  /home/siop/${PORT_CHOICE}/output/* ; do cat $N ; echo -n " " ; done| paste -sd " "|sed 's/ /  /g')

  clear
header
 tput rev
  echo -n ":      Current pin states for --> "
 tput rmso
  echo -n "     $PORT_CHOICE    "
 tput rev
  echo ":"
  echo "$bs"
 tput rmso
 tput rev
  echo ":                Input Pins #                   :"
  echo ":               10 11 12 13 15                  :"
  echo -n ":"
 tput rmso
  echo -n "                $OLD_INPUT_CHOICE                "
 tput rev
  echo ":"
  echo "$bs"
 tput rmso
 tput rev
  echo ":     Output Pins #, set via typing it's #      :"
  echo ":      1 14 16 17  2  3  4  5  6  7  8  9       :"
  echo -n ":"
 tput rmso
  echo -n "      $OLD_OUTPUT_CHOICE     " 
 tput rev
  echo ":"
  echo "$bs"
  echo ": Type p to pick which port or a pin # to edit  :"
  echo ":...   or Q/0 to quit then hit Enter key.    ...:"
 tput rmso
  echo ""
  read SIMPLEIO_MENU 
   case $SIMPLEIO_MENU in
	p|P)			use_what_port;;
	[1-9]|14|16|17)		set_high_low;;
	Q|q|0|Q/0|q/0)		clean_up;;
   esac
show_current_settings
}

use_what_port(){
  echo "    Type 0 or 1 or 2 then hit Enter/Return Key."
  read PORT_CHOICE
   case $PORT_CHOICE in
	0|1|2)          sed -i 's/^\(.*\)port./\1port'$PORT_CHOICE'/' temp.data
	show_current_settings;;
   esac
use_what_port
}

set_high_low() {
  echo " Set output 1 for high or 0 for low."
  echo -n "Type either 1 or 0 then hit Enter/Return Key."
  read SET_HIGH_LOW_CHOICE
   case $SET_HIGH_LOW_CHOICE in
	1|0)
#  echo "Set to ${SET_HIGH_LOW_CHOICE}"
  echo "${SET_HIGH_LOW_CHOICE}" > /home/siop/$PORT_CHOICE/output/pin${SIMPLEIO_MENU}
    show_current_settings;;
   esac
 set_high_low
}

clean_up() {
  clear
  exit
}

while true ; do
  show_current_settings
done
echo
